package cn.ibizlab.core.data.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.data.domain.DOSchema;
import cn.ibizlab.core.data.filter.DOSchemaSearchContext;


/**
 * 实体[DOSchema] 服务对象接口
 */
public interface IDOSchemaService {

    boolean create(DOSchema et);
    void createBatch(List<DOSchema> list);
    boolean update(DOSchema et);
    void updateBatch(List<DOSchema> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    DOSchema get(String key);
    DOSchema getDraft(DOSchema et);
    boolean checkKey(DOSchema et);
    boolean save(DOSchema et);
    void saveBatch(List<DOSchema> list);
    Page<DOSchema> searchDefault(DOSchemaSearchContext context);

}



