package cn.ibizlab.core.data.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.data.domain.DTOSchema;
import cn.ibizlab.core.data.filter.DTOSchemaSearchContext;


/**
 * 实体[DTOSchema] 服务对象接口
 */
public interface IDTOSchemaService {

    boolean create(DTOSchema et);
    void createBatch(List<DTOSchema> list);
    boolean update(DTOSchema et);
    void updateBatch(List<DTOSchema> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    DTOSchema get(String key);
    DTOSchema getDraft(DTOSchema et);
    boolean checkKey(DTOSchema et);
    boolean save(DTOSchema et);
    void saveBatch(List<DTOSchema> list);
    Page<DTOSchema> searchDefault(DTOSchemaSearchContext context);

}



