package cn.ibizlab.core.data.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.data.domain.POSchema;
import cn.ibizlab.core.data.filter.POSchemaSearchContext;


/**
 * 实体[POSchema] 服务对象接口
 */
public interface IPOSchemaService {

    boolean create(POSchema et);
    void createBatch(List<POSchema> list);
    boolean update(POSchema et);
    void updateBatch(List<POSchema> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    POSchema get(String key);
    POSchema getDraft(POSchema et);
    boolean checkKey(POSchema et);
    boolean save(POSchema et);
    void saveBatch(List<POSchema> list);
    Page<POSchema> searchDefault(POSchemaSearchContext context);

}



